<?php

class AIImagePro_Editor
{
    private AIImagePro_Settings $settings;
    public function __construct()
    {
        $this->settings = AIImagePro_Settings::instance();
    }
    public function render()
    {
        $preferred_editor = $this->settings->get_option(AIImagePro_Settings::OPTION_PREFERRED_AI_EDITOR);

        $first_tab_id = $preferred_editor === 'dalle' ? 'dalle' : 'stability-ai';
        $second_tab_id = $preferred_editor === 'dalle' ? 'stability-ai' : 'dalle';

        $first_title = $preferred_editor === 'dalle' ? esc_html__('Dall.E', 'ai-image-pro') : esc_html__('Stable Diffusion', 'ai-image-pro');
        $second_title = $preferred_editor === 'dalle' ? esc_html__('Stable Diffusion', 'ai-image-pro') : esc_html__('Dall.E', 'ai-image-pro');

        $url_to_icon = plugins_url('../../assets/icons/ai-image-pro-icon.svg', __FILE__ );

        ###['demo-message']

        ?>
        <div class="wrap ai-image-pro-editor-container" >
            <div class="ai-image-pro-heading-container">
                <img class="ai-image-pro-logo" src="<?php echo $url_to_icon; ?>" />
                <h1 class="ai-image-pro-heading"><?php echo esc_html( get_admin_page_title() ); ?></h1>
            </div>
            <div class="row mt-2">
                <div class="col-4">
                    <div class="row">
                        <div class="col-12">
                            <div id="ai-image-pro-editor" class="">
                                <ul class="nav nav-tabs border border-0" id="ai-image-pro-editor-tabs" role="tablist">
                                    <li class="nav-item" role="presentation">
                                        <button class="nav-link active" id="<?php echo $first_tab_id ?>-tab" data-bs-toggle="tab" data-bs-target="#<?php echo $first_tab_id ?>-pane" type="button" role="tab" aria-controls="home-tab-pane" ><?php echo $first_title ?></button>
                                    </li>
                                    <li class="nav-item" role="presentation">
                                        <button class="nav-link" id="<?php echo $second_tab_id ?>-tab" data-bs-toggle="tab" data-bs-target="#<?php echo $second_tab_id ?>-pane" type="button" role="tab" aria-controls="profile-tab-pane" ><?php echo $second_title ?></button>
                                    </li>
                                </ul>
                                <div class="tab-content" id="ai-image-pro-editor-panes">
                                    <div class="tab-pane fade show active" id="<?php echo $first_tab_id ?>-pane" role="tabpanel" aria-labelledby="<?php echo $first_tab_id ?>-tab" tabindex="0">
                                        <?php $this->get_tab_content($first_tab_id); ?>
                                    </div>
                                    <div class="tab-pane fade" id="<?php echo $second_tab_id ?>-pane" role="tabpanel" aria-labelledby="dream-studio-tab" tabindex="0">
                                        <?php $this->get_tab_content($second_tab_id); ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="row mt-3">
                        <div class="col-12">
                            <div id="ai-image-pro-multiple-images-generations-pane-container">
                                <h6><?php echo esc_html__( 'Image generations', 'ai-image-pro' ); ?></h6>
                                <div id="ai-image-pro-multiple-images-generations-pane">
                                    <div id="ai-image-pro-multiple-images-generations">
                                        <div class="row">

                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
                <div class="col-8 ai-image-pro-image-controls-container">
                    <div class="row">
                        <div class="col-12 ai-image-pro-undo-redo-toolbar d-flex justify-content-center">
                            <button id="ai-image-pro-undo-button" type="button" class="btn btn-outline-secondary btn-sm m-1 float-start disabled"><i class="bi bi-arrow-counterclockwise"></i></button>
                            <button id="ai-image-pro-redo-button" type="button" class="btn btn-outline-secondary btn-sm m-1 float-start disabled"><i class="bi bi-arrow-clockwise"></i></button>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-3">
                            <button id="ai-image-pro-media-library-button" type="button" class="btn btn-outline-secondary btn-sm m-1 float-start"><i class="bi bi-image"></i> <?php echo esc_html__( 'Import', 'ai-image-pro' ); ?></button>
                        </div>
                        <div class="col-6">
                            <? $this->toolbar(); ?>
                        </div>
                        <div class="col-3 justify-content-end">
                            <button id="ai-image-pro-save-to-media-gallery-button" type="button" class="btn btn-sm btn-outline-success m-1 float-end disabled"><i class="bi bi-check-circle-fill"></i> <?php echo esc_html__( 'Save', 'ai-image-pro' ); ?></button>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col text-center">
                            <? $this->toolbarPanes(); ?>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-12">
                            <div class="ai-image-pro-editor-canvas-container-container" >
                                <div class="ai-image-pro-editor-canvas-container">
                                    <div class="ai-image-pro-editor-main-canvas-container">
                                        <canvas id="ai-image-pro-editor-canvas" ></canvas>
                                    </div>
                                    <div class="ai-image-pro-editor-mask-canvas-container">
                                        <canvas id="ai-image-pro-mask-canvas" ></canvas>
                                    </div>
                                    <div class="ai-image-pro-editor-cropper-container">
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>

            <div id="ai-image-pro-editor-toolbar-item-brush-size-slider">
                <div class="row d-flex justify-content-center mt-1">
                    <div class="col">
                        <input type="range" class="form-range" min="1" max="100" value="20" step="1" id="ai-image-pro-editor-toolbar-item-brush-size-slider-range">
                    </div>
                </div>
                <div class="row d-flex justify-content-center mt-1">
                    <div class="col">
                        <button id="ai-image-pro-editor-toolbar-item-clear-mask-brush" type="button" class="btn btn-outline-secondary btn-sm">
                            <span class="d-inline-block ai-image-pro-popover ai-image-pro-editor-edit-image-tip" data-bs-toggle="popover" data-bs-trigger="manual" data-bs-content="<?php echo esc_html__( 'Brush over the parts in the images that you want AI to edit.', 'ai-image-pro' ); ?>">
                                <i class="bi bi-trash3"></i>
                            </span>
                        </button>
                    </div>
                </div>
            </div>

            <div id="ai-image-pro-editor-overlay"></div>

            <div id="ai-image-pro-multiple-images-selector">
                <h3><?php echo esc_html__( 'Pick an image', 'ai-image-pro' ); ?></h3>
                <p><?php echo esc_html__( 'Don\'t worry, the rest of the images will not go anywhere. You can always pick any of these images from the side image pane later.', 'ai-image-pro' ); ?></p>
                <div id="ai-image-pro-multiple-images-selector-container">
                </div>

                <div id="ai-image-pro-multiple-images-selector-button-controls" class="float-end mt-4">
                    <a href="#" id="ai-image-pro-multiple-images-cancel-button"><?php echo esc_html__( 'Cancel', 'ai-image-pro' ); ?></a>
                    <button id="ai-image-pro-multiple-images-pick-button" type="button" class="btn btn-outline-secondary disabled"><?php echo esc_html__( 'Pick this image', 'ai-image-pro' ); ?></button>
                </div>

                <div id="ai-image-pro-multiple-images-selector-close">
                    <button type="button" class="btn-close btn-close-white ai-image-pro-multiple-images-selector-close-button" aria-label="Close"></button>
                </div>
            </div>

            <div class="ai-image-pro-dev-tools">
                <h6>Dev tools</h6>
                <div>
                    <button id="ai-image-pro-download-mask-button" type="button" class="btn btn-sm btn-outline-secondary"><?php echo esc_html__( 'Download Mask', 'ai-image-pro' ); ?></button>
                    <button id="ai-image-pro-download-image-button" type="button" class="btn btn-sm btn-outline-secondary"><?php echo esc_html__( 'Download Image', 'ai-image-pro' ); ?></button>
                </div>
            </div>
        </div>
        <?php
    }

    private function get_tab_content($editor_id)
    {
        if ($editor_id == 'dalle') {
            $this->dalle();
        } else {
            $this->stability_ai();
        }
    }

    private function dalle()
    {
        ?>
        <ul class="nav nav-pills nav-fill nav-justified" role="tablist">
            <li class="nav-item border-radius-left" role="presentation">
                <a class="nav-link active" aria-current="page" href="#" data-bs-toggle="tab" data-bs-target="#ai-image-pro-dalle-generate-pane"> <i class="bi bi-images"></i> <?php echo esc_html__( 'Generate', 'ai-image-pro' ); ?></a>
            </li>
            <li class="nav-item no-border-radius" role="presentation">
                <a class="nav-link" href="#" data-bs-toggle="tab" data-bs-target="#ai-image-pro-dalle-edit-pane"><i class="bi bi-pencil" ></i> <?php echo esc_html__( 'Edit', 'ai-image-pro' ); ?></a>
            </li>
            <li class="nav-item border-radius-right" role="presentation">
                <a class="nav-link" href="#" data-bs-toggle="tab" data-bs-target="#ai-image-pro-dalle-variations-pane"><i class="bi bi-front"></i> <?php echo esc_html__( 'Variations', 'ai-image-pro' ); ?></a>
            </li>
        </ul>
        <div class="tab-content" id="myTabContent">
            <div class="tab-pane fade show active" id="ai-image-pro-dalle-generate-pane" role="tabpanel" tabindex="0">
                <?php $this->dalle_pane_generate(); ?>
            </div>
            <div class="tab-pane fade" id="ai-image-pro-dalle-edit-pane" role="tabpanel" tabindex="0">
                <?php $this->dalle_pane_edit(); ?>
            </div>
            <div class="tab-pane fade" id="ai-image-pro-dalle-variations-pane" role="tabpanel" tabindex="0">
                <?php $this->dalle_pane_variations(); ?>
            </div>
        </div>


        <?php
    }

    private function dalle_pane_generate()
    {
        ?>
        <div class="row">
            <div class="col-12">
                <div class="row">
                    <div class="col-12">
                        <?php $this->prompt_guide(); ?>
                    </div>
                </div>

                <div class="row">
                    <div class="col-12">
                        <div class="form-floating">
                            <?php $this->dalle_prompt('ai-image-pro-dalle-generate-prompt'); ?>
                        </div>
                    </div>
                </div>

                <div class="row mt-2">
                    <div class="col">
                        <button id="ai-image-pro-dalle-generate-button" type="button" class="btn btn-sm btn-primary float-end mt-1"><i class="bi bi-images"></i> <?php echo esc_html__( 'Generate', 'ai-image-pro' ); ?></button>
                    </div>
                </div>

                <div class="row mt-3">
                    <div class="col">
                        <?php $this->dalle_image_size('ai-image-pro-dalle-generate-image-size') ?>
                    </div>
                    <div class="col">
                        <?php $this->dalle_number_of_images('ai-image-pro-dalle-generate-count') ?>
                    </div>
                </div>
            </div>

        </div>
        <?php
    }

    private function dalle_pane_edit()
    {
        ?>
        <div class="row">
            <div class="col-12">
                <div class="row">
                    <div class="col-12">
                        <?php $this->prompt_guide(); ?>
                    </div>
                </div>

                <div class="row">
                    <div class="col-12">
                        <div class="form-floating">
                            <?php $this->dalle_prompt('ai-image-pro-dalle-edit-prompt'); ?>
                        </div>
                    </div>
                </div>

                <div class="row mt-2">
                    <div class="col float-end">
                        <button id="ai-image-pro-dalle-perform-edit-button" type="button" class="btn btn-sm float-end btn-outline-secondary m-1"><i class="bi bi-check"></i> <?php echo esc_html__( 'Confirm Edit', 'ai-image-pro' ); ?></button>
                        <button id="ai-image-pro-dalle-cancel-edit-button" type="button" class="btn btn-sm float-end btn-outline-secondary m-1"><i class="bi bi-x"></i> <?php echo esc_html__( 'Cancel', 'ai-image-pro' ); ?></button>
                        <button id="ai-image-pro-dalle-draw-mask-button" type="button" class="btn float-end btn-sm btn-primary disabled m-1 ai-image-pro-primary-button">
                            <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Edit image by highlighting the parts you want the AI to edit', 'ai-image-pro' ); ?>">
                                <i class="bi bi-pencil"></i> <?php echo esc_html__( 'Start Editing', 'ai-image-pro' ); ?>
                            </span>
                        </button>
                    </div>

                </div>

                <div class="row mt-3">
                    <div class="col">
                        <?php $this->dalle_image_size('ai-image-pro-dalle-edit-image-size') ?>
                    </div>
                    <div class="col">
                        <?php $this->dalle_number_of_images('ai-image-pro-dalle-edit-count') ?>
                    </div>
                </div>
            </div>

        </div>
        <?php
    }

    private function dalle_pane_variations()
    {
        ?>
        <div class="row">
            <div class="col-12">

                <div class="row mt-1">
                    <div class="col">
                        <?php $this->dalle_image_size('ai-image-pro-dalle-variations-image-size') ?>
                    </div>
                    <div class="col">
                        <?php $this->dalle_number_of_images('ai-image-pro-dalle-variations-count') ?>
                    </div>
                </div>

                <div class="row mt-3">
                    <div class="col">

                        <button id="ai-image-pro-dalle-image-variations-button" type="button" class="btn btn-sm float-end btn-primary disabled mt-1 ai-image-pro-primary-button">
                            <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Generate variations that are similar to the current image.', 'ai-image-pro' ); ?>">
                                <i class="bi bi-front"></i> <?php echo esc_html__( 'Generate Variations', 'ai-image-pro' ); ?>
                            </span>
                        </button>
                    </div>

                </div>

            </div>

        </div>
        <?php
    }

    private function dalle_prompt($id)
    {
        ?>
        <textarea class="form-control ai-image-pro-prompt-input" id="<?php echo $id ?>" rows="5" cols="100" placeholder="<?php echo esc_html__( 'Prompt', 'ai-image-pro' ); ?>"></textarea>
        <label for="<?php echo $id ?>"><?php echo esc_html__( 'Prompt', 'ai-image-pro' ); ?></label>
        <?php
    }

    private function dalle_image_size($id)
    {
        ?>
        <div class="form-group">
            <label for="<?php echo $id ?>" class="ai-image-pro-label">
            <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Size of generated image', 'ai-image-pro' ); ?>">
                <?php echo esc_html__( 'Image size', 'ai-image-pro' ); ?>
            </span>
            </label>
            <select class="form-control form-control-sm" id="<?php echo $id ?>">
                <option value="small"><?php echo esc_html__( 'Small (256x256)', 'ai-image-pro' ); ?></option>
                <option value="medium" selected><?php echo esc_html__( 'Medium (512x512)', 'ai-image-pro' ); ?></option>
                <option value="large"><?php echo esc_html__( 'Large (1024x1024)', 'ai-image-pro' ); ?></option>
            </select>
        </div>
        <?php
    }

    private function dalle_number_of_images($id)
    {
        ?>
        <div class="row mt-1">
            <div class="col-10">
                <label for="<?php echo $id ?>" class="form-label ai-image-pro-label">
                <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Number of images to generate', 'ai-image-pro' ); ?>">
                    <?php echo esc_html__( 'Number of Images', 'ai-image-pro' ); ?>
                </span>
                </label>
                <input type="range" class="form-range ai-image-pro-range" id="<?php echo $id ?>" value="1" step="1" min="1" max="10">
            </div>
            <div class="col-2 mt-4 text-center justify-content-center p-0">
                <span class="ai-image-pro-range-value border">1</span>
            </div>
        </div>
        <?php
    }

    private function stability_ai()
    {
        ?>
        <ul class="nav nav-pills nav-fill nav-justified">
            <li class="nav-item border-radius-left">
                <a class="nav-link active" aria-current="page" href="#" data-bs-toggle="tab" data-bs-target="#ai-image-pro-stabilityai-generate-pane"> <i class="bi bi-images"></i> <?php echo esc_html__( 'Generate', 'ai-image-pro' ); ?></a>
            </li>
            <li class="nav-item border-radius-right">
                <a class="nav-link" href="#" data-bs-toggle="tab" data-bs-target="#ai-image-pro-stabilityai-edit-pane"><i class="bi bi-pencil"></i> <?php echo esc_html__( 'Edit', 'ai-image-pro' ); ?></a>
            </li>
        </ul>
        <div class="tab-content" id="myTabContent">
            <div class="tab-pane fade show active" id="ai-image-pro-stabilityai-generate-pane" role="tabpanel" tabindex="0">
                <?php $this->stability_ai_pane_generate(); ?>
            </div>
            <div class="tab-pane fade" id="ai-image-pro-stabilityai-edit-pane" role="tabpanel" tabindex="0">
                <?php $this->stability_ai_pane_edit(); ?>
            </div>
        </div>


        <?php
    }

    private function stability_ai_pane_generate()
    {
        ?>
        <div class="row">
            <div class="col-12">
                <div class="row">
                    <div class="col-12">
                        <?php $this->prompt_guide(); ?>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <?php $this->stability_ai_prompt('ai-image-pro-stabilityai-generate-prompt'); ?>
                    </div>
                </div>

                <div class="row mt-2">
                    <div class="col">
                        <button id="ai-image-pro-stabilityai-generate-button" type="button" class="btn btn-sm btn-primary float-end mt-1"><i class="bi bi-images"></i> <?php echo esc_html__( 'Generate', 'ai-image-pro' ); ?></button>
                    </div>
                </div>

                <div class="row mt-3">
                    <div class="col">
                        <?php $this->stability_ai_model('ai-image-pro-stabilityai-generate-engine'); ?>
                    </div>

                    <div class="col">
                        <?php $this->stability_ai_sampler('ai-image-pro-stabilityai-generate-sampler'); ?>
                    </div>
                </div>
                <div class="row mt-3 p-2">

                    <div class="col">
                        <?php $this->stability_ai_width('ai-image-pro-stabilityai-generate-image-width'); ?>
                    </div>

                    <div class="col">
                        <?php $this->stability_ai_height('ai-image-pro-stabilityai-generate-image-height'); ?>
                    </div>

                </div>

                <div class="row mt-3 p-2">

                    <div class="col">
                        <?php $this->stability_ai_number_of_images('ai-image-pro-stabilityai-generate-count'); ?>
                    </div>

                    <div class="col">
                        <?php $this->stability_ai_number_of_steps('ai-image-pro-stabilityai-generate-steps'); ?>
                    </div>
                </div>

                <div class="row mt-3 p-2">
                    <div class="col">
                        <?php $this->stability_ai_cfg_scale('ai-image-pro-stabilityai-generate-cfg'); ?>
                    </div>

                    <div class="col">
                        <?php $this->stability_ai_seed('ai-image-pro-stabilityai-generate-seed'); ?>
                    </div>
                </div>

            </div>

        </div>
        <?php
    }

    private function stability_ai_pane_edit()
    {
        ?>
        <div class="row">
            <div class="col-12">
                <div class="row">
                    <div class="col-12">
                        <?php $this->prompt_guide(); ?>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <?php $this->stability_ai_prompt('ai-image-pro-stabilityai-edit-prompt'); ?>
                    </div>
                </div>

                <div class="row mt-2">
                    <div class="col">

                        <button id="ai-image-pro-stabilityai-perform-edit-button" type="button" class="btn btn-sm float-end btn-primary ai-image-pro-primary-button m-1"><i class="bi bi-check"></i> <?php echo esc_html__( 'Confirm Edit', 'ai-image-pro' ); ?></button>
                        <button id="ai-image-pro-stabilityai-cancel-edit-button" type="button" class="btn btn-sm float-end btn-outline-secondary m-1"><i class="bi bi-x"></i> <?php echo esc_html__( 'Cancel', 'ai-image-pro' ); ?></button>
                        <button id="ai-image-pro-stabilityai-draw-mask-button" type="button" class="btn btn-sm float-end btn-primary ai-image-pro-primary-button disabled m-1">
                            <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Edit image by highlighting the parts you want the AI to edit', 'ai-image-pro' ); ?>">
                                <i class="bi bi-pencil"></i> <?php echo esc_html__( 'Start Editing', 'ai-image-pro' ); ?>
                            </span>
                        </button>
                    </div>
                </div>

                <div class="row mt-3">
                    <div class="col">
                        <?php $this->stability_ai_model('ai-image-pro-stabilityai-edit-engine', true); ?>
                    </div>

                    <div class="col">
                        <?php $this->stability_ai_sampler('ai-image-pro-stabilityai-edit-sampler'); ?>
                    </div>
                </div>

                <div class="row mt-3 p-2">

                    <div class="col">
                        <?php $this->stability_ai_number_of_images('ai-image-pro-stabilityai-edit-count'); ?>
                    </div>

                    <div class="col">
                        <?php $this->stability_ai_number_of_steps('ai-image-pro-stabilityai-edit-steps'); ?>
                    </div>
                </div>

                <div class="row mt-3 p-2">
                    <div class="col">
                        <?php $this->stability_ai_cfg_scale('ai-image-pro-stabilityai-edit-cfg'); ?>
                    </div>

                    <div class="col">
                        <?php $this->stability_ai_seed('ai-image-pro-stabilityai-edit-seed'); ?>
                    </div>
                </div>

            </div>

        </div>
        <?php
    }

    private function stability_ai_prompt($id)
    {
        ?>
        <div class="form-floating">
            <textarea class="form-control ai-image-pro-prompt-input" id="<?php echo $id ?>" rows="5" cols="100" placeholder="<?php echo esc_html__( 'Prompt', 'ai-image-pro' ); ?>"></textarea>
            <label for="<?php echo $id ?>"><?php echo esc_html__( 'Prompt', 'ai-image-pro' ); ?></label>
        </div>
        <?php
    }

    private function stability_ai_model($id, $in_painting = false)
    {
        if ($in_painting) {
            ?>
            <div class="form-group">
                <label for="<?php echo $id ?>" class="ai-image-pro-label">
                <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Model to use in the image in-painting process', 'ai-image-pro' ); ?>">
                    <?php echo esc_html__( 'Model', 'ai-image-pro' ); ?>
                </span>
                </label>
                <select class="form-control form-control-sm" id="<?php echo $id ?>">
                    <option value="stable-inpainting-v1-0"><?php echo esc_html__( 'Stable Inpainting v1.0', 'ai-image-pro' ); ?></option>
                    <option value="stable-inpainting-512-v2-0" selected><?php echo esc_html__( 'Stable Inpainting v2.0', 'ai-image-pro' ); ?></option>
                </select>
            </div>
            <?php

            return;
        }

        $default_model = $this->settings->get_option(AIImagePro_Settings::OPTION_STABILITY_AI_DEFAULT_MODEL);
        ?>
        <div class="form-group">
            <label for="<?php echo $id ?>" class="ai-image-pro-label">
                <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Model to use in the image generation process', 'ai-image-pro' ); ?>">
                    <?php echo esc_html__( 'Model', 'ai-image-pro' ); ?>
                </span>
            </label>
            <select class="form-control form-control-sm" id="<?php echo $id ?>">
                <option value="stable-diffusion-v1-5" <?php selected('stable-diffusion-v1-5', $default_model, true); ?>><?php echo esc_html__( 'Stable Diffusion v1.5', 'ai-image-pro' ); ?></option>
                <option value="stable-diffusion-v1" <?php selected('stable-diffusion-v1', $default_model, true); ?>><?php echo esc_html__( 'Stable Diffusion v1.4', 'ai-image-pro' ); ?></option>
                <option value="stable-diffusion-512-v2-0" <?php selected('stable-diffusion-512-v2-0', $default_model, true); ?>><?php echo esc_html__( 'Stable Diffusion v2.0', 'ai-image-pro' ); ?></option>
                <option value="stable-diffusion-512-v2-1" <?php selected('stable-diffusion-512-v2-1', $default_model, true); ?>><?php echo esc_html__( 'Stable Diffusion v2.1', 'ai-image-pro' ); ?></option>
                <option value="stable-diffusion-768-v2-1" <?php selected('stable-diffusion-768-v2-1', $default_model, true); ?>><?php echo esc_html__( 'Stable Diffusion v2.1-768', 'ai-image-pro' ); ?></option>
                <option value="stable-diffusion-xl-beta-v2-2-2" <?php selected('stable-diffusion-xl-beta-v2-2-2', $default_model, true); ?>><?php echo esc_html__( 'Stable Diffusion v2.2.2-XL Beta', 'ai-image-pro' ); ?></option>
            </select>
        </div>
        <?php
    }

    private function stability_ai_sampler($id)
    {
        $default_sampler = $this->settings->get_option(AIImagePro_Settings::OPTION_STABILITY_AI_DEFAULT_SAMPLER);
        ?>
        <div class="form-group">
            <label for="<?php echo $id ?>" class="ai-image-pro-label">
                <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'A sampler determines how the image is "calculated". A sampler processes an input (prompt) to produce an output (image). Since these samplers are different mathematically, they will produce difference results for the same prompt.', 'ai-image-pro' ); ?>">
                    <?php echo esc_html__( 'Sampler', 'ai-image-pro' ); ?>
                </span>
            </label>
            <select class="form-control form-control-sm" id="<?php echo $id ?>">
                <option value="DDIM" <?php selected('DDIM', $default_sampler, true); ?>><?php echo esc_html__( 'DDIM', 'ai-image-pro' ); ?></option>
                <option value="DDPM" <?php selected('DDPM', $default_sampler, true); ?>><?php echo esc_html__( 'DDPM', 'ai-image-pro' ); ?></option>
                <option value="K_DPMPP_2M" <?php selected('K_DPMPP_2M', $default_sampler, true); ?>><?php echo esc_html__( 'K_DPMPP_2M', 'ai-image-pro' ); ?></option>
                <option value="K_DPMPP_2S_ANCESTRAL" <?php selected('K_DPMPP_2S_ANCESTRAL', $default_sampler, true); ?>><?php echo esc_html__( 'K_DPMPP_2S_ANCESTRAL', 'ai-image-pro' ); ?></option>
                <option value="K_DPM_2" <?php selected('K_DPM_2', $default_sampler, true); ?>><?php echo esc_html__( 'K_DPM_2', 'ai-image-pro' ); ?></option>
                <option value="K_DPM_2_ANCESTRAL" <?php selected('K_DPM_2_ANCESTRAL', $default_sampler, true); ?>><?php echo esc_html__( 'K_DPM_2_ANCESTRAL', 'ai-image-pro' ); ?></option>
                <option value="K_EULER" <?php selected('K_EULER', $default_sampler, true); ?>><?php echo esc_html__( 'K_EULER', 'ai-image-pro' ); ?></option>
                <option value="K_EULER_ANCESTRAL" <?php selected('K_EULER_ANCESTRAL', $default_sampler, true); ?>><?php echo esc_html__( 'K_EULER_ANCESTRAL', 'ai-image-pro' ); ?></option>
                <option value="K_HEUN" <?php selected('K_HEUN', $default_sampler, true); ?>><?php echo esc_html__( 'K_HEUN', 'ai-image-pro' ); ?></option>
                <option value="K_LMS" <?php selected('K_LMS', $default_sampler, true); ?>><?php echo esc_html__( 'K_LMS', 'ai-image-pro' ); ?></option>
            </select>
        </div>
        <?php
    }

    private function stability_ai_width($id)
    {
        ?>
        <div class="row">
            <div class="col-10">
                <label for="<?php echo $id ?>" class="form-label ai-image-pro-label">
                    <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Width of generated image in pixels', 'ai-image-pro' ); ?>">
                        <?php echo esc_html__( 'Width', 'ai-image-pro' ); ?>
                    </span>
                </label>
                <input type="range" class="form-range ai-image-pro-range" id="<?php echo $id ?>" value="512" step="64" min="128" max="1024">
            </div>
            <div class="col-2 mt-4 text-center justify-content-center p-0">
                <span class="ai-image-pro-range-value border">512</span>
            </div>
        </div>
        <?php
    }

    private function stability_ai_height($id)
    {
        ?>
        <div class="row">
            <div class="col-10">
                <label for="<?php echo $id ?>" class="form-label ai-image-pro-label">
                    <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Height of generated image in pixels', 'ai-image-pro' ); ?>">
                        <?php echo esc_html__( 'Height', 'ai-image-pro' ); ?>
                    </span>
                </label>
                <input type="range" class="form-range ai-image-pro-range" id="<?php echo $id ?>" value="512" step="64" min="128" max="1024">
            </div>
            <div class="col-2 mt-4 text-center justify-content-center p-0">
                <span class="ai-image-pro-range-value border">512</span>
            </div>
        </div>
        <?php
    }

    private function stability_ai_number_of_images($id)
    {
        ?>
        <div class="row">
            <div class="col-10">
                <label for="<?php echo $id ?>" class="form-label ai-image-pro-label">
                    <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Number of Images to generate', 'ai-image-pro' ); ?>">
                        <?php echo esc_html__( 'Number of Images', 'ai-image-pro' ); ?>
                    </span>
                </label>
                <input type="range" class="form-range ai-image-pro-range" id="<?php echo $id ?>" value="1" step="1" min="1" max="10">
            </div>
            <div class="col-2 mt-4 text-center justify-content-center p-0">
                <span class="ai-image-pro-range-value border">1</span>
            </div>
        </div>
        <?php
    }

    private function stability_ai_number_of_steps($id)
    {
        $default_steps = $this->settings->get_option(AIImagePro_Settings::OPTION_STABILITY_AI_NUMBER_OF_STEPS);
        ?>
        <div class="row">
            <div class="col-10">
                <label for="<?php echo $id ?>" class="form-label ai-image-pro-label">
                    <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Generation steps control how many times the image is sampled. Increasing the number of steps might give you better results, up to a point where there\'re diminishing returns. More steps would also cost you more.', 'ai-image-pro' ); ?>">
                        <?php echo esc_html__( 'Number of Steps', 'ai-image-pro' ); ?>
                    </span>
                </label>
                <input type="range" class="form-range ai-image-pro-range" id="<?php echo $id ?>" value="<?php echo $default_steps ?>" step="1" min="10" max="150">
            </div>
            <div class="col-2 mt-4 text-center justify-content-center p-0">
                <span class="ai-image-pro-range-value border">30</span>
            </div>
        </div>
        <?php
    }

    private function stability_ai_cfg_scale($id)
    {
        ?>
        <div class="row">
            <div class="col-10">
                <label for="<?php echo $id ?>" class="form-label ai-image-pro-label">
                    <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Prompt strength (CFG scale) controls how much the final image will adhere to your prompt. Lower values would give the model more "creativity", while higher values will produce a final image that\'s close to your prompt.', 'ai-image-pro' ); ?>">
                        <?php echo esc_html__( 'Prompt strength', 'ai-image-pro' ); ?>
                    </span>
                </label>
                <input type="range" class="form-range ai-image-pro-range" id="<?php echo $id ?>" value="7" step="1" min="0" max="35">
            </div>
            <div class="col-2 mt-4 text-center justify-content-center p-0">
                <span class="ai-image-pro-range-value border">7</span>
            </div>
        </div>
        <?php
    }

    private function stability_ai_seed($id)
    {
        ?>
        <div class="mb-3">
            <label for="<?php echo $id ?>" class="form-label ai-image-pro-label">
                <span class="d-inline-block ai-image-pro-popover" data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-content="<?php echo esc_html__( 'Seed is a number used to initialize the image generation. Using a certain seed with same settings will produce the same image. "0" means a random seed will be used everytime.', 'ai-image-pro' ); ?>">
                    <?php echo esc_html__( 'Seed', 'ai-image-pro' ); ?>
                </span>
            </label>
            <input type="number" class="form-control form-control-sm" id="<?php echo $id ?>" value="0">
        </div>
        <?php
    }

    private function prompt_guide()
    {
        ?>
            <span class="d-inline-block ai-image-pro-popover ai-image-pro-prompt-guide-container" data-bs-toggle="popover-with-click" data-bs-content="<?php echo esc_html__( 'Prompting is an art in itself. Check the following resources to understand how to write better prompts:', 'ai-image-pro' ); ?> <a href='https://strikingloo.github.io/stable-diffusion-vs-dalle-2' target='_blank'><?php echo esc_html__( 'Prompt guide', 'ai-image-pro' ); ?></a>, <a href='https://proximacentaurib.notion.site/e28a4f8d97724f14a784a538b8589e7d?v=42948fd8f45c4d47a0edfc4b78937474&p=9aa9c42e061146fa8a39af4f33d46d48&pm=s' target='_blank'><?php echo esc_html__( 'Stable Diffusion art styles', 'ai-image-pro' ); ?></a>, <a href='https://www.youtube.com/results?search_query=how+to+write+prompts+dalle' target='_blank'><?php echo esc_html__( 'Dall.E prompt videos', 'ai-image-pro' ); ?></a>, <a href='https://www.youtube.com/results?search_query=how+to+write+prompts+stable+diffusion' target='_blank'><?php echo esc_html__( 'Stable Diffusion prompt videos', 'ai-image-pro' ); ?></a> ">
                <a class="ai-image-pro-prompt-guide"><?php echo esc_html__( '?', 'ai-image-pro' ); ?></a>
            </span>
        <?php
    }


    private function toolbar()
    {
        ?>
        <div class="ai-image-pro-editor-toolbar m-2 text-center">
            <div class="ai-image-pro-editor-toolbar-item">
                <button id="ai-image-pro-editor-toolbar-item-crop-button" type="button" class="btn btn-sm btn-outline-secondary disabled">
                    <i class="bi bi-crop"></i>
                    <span><?php echo esc_html__( 'Crop', 'ai-image-pro' ); ?></span>
                </button>
                <button id="ai-image-pro-editor-toolbar-item-filters-button" type="button" class="btn btn-sm btn-outline-secondary disabled">
                    <i class="bi bi-eyeglasses"></i>
                    <span><?php echo esc_html__( 'Filters', 'ai-image-pro' ); ?></span>
                </button>
                <button id="ai-image-pro-editor-toolbar-item-fine-tunes-button" type="button" class="btn btn-sm btn-outline-secondary disabled">
                    <i class="bi bi-sliders2-vertical"></i>
                    <span><?php echo esc_html__( 'Fine-tune', 'ai-image-pro' ); ?></span>
                </button>
            </div>

        </div>
        <?php
    }

    private function toolbarPanes()
    {
        ?>
        <div class="ai-image-pro-editor-toolbar-panes">
            <div id="ai-image-pro-editor-toolbar-pane-crop">
                <button id="ai-image-pro-editor-toolbar-item-crop-cancel-button" type="button" class="btn btn-sm btn-outline-secondary">
                    <i class="bi bi-x"></i>
                    <span><?php echo esc_html__( 'Cancel', 'ai-image-pro' ); ?></span>
                </button>
                <button id="ai-image-pro-editor-toolbar-item-crop-1-1-ratio" type="button" class="btn btn-sm btn-outline-secondary ms-2 me-2">
                    <i class="bi bi-square"></i>
                    <span><?php echo esc_html__( '1:1', 'ai-image-pro' ); ?></span>
                </button>
                <button id="ai-image-pro-editor-toolbar-item-crop-confirm-button" type="button" class="btn btn-sm btn-outline-secondary">
                    <i class="bi bi-check"></i>
                    <span><?php echo esc_html__( 'Confirm', 'ai-image-pro' ); ?></span>
                </button>
            </div>
            <div id="ai-image-pro-editor-toolbar-pane-filters">

            </div>
            <div id="ai-image-pro-editor-toolbar-pane-fine-tunes">
                <div id="ai-image-pro-editor-toolbar-pane-fine-tunes-buttons">

                </div>
                <div id="ai-image-pro-editor-toolbar-pane-fine-tunes-ranges">

                </div>
            </div>
        </div>
        <?php
    }

    public function enqueue_scripts( $hook ) {
        if ( 'toplevel_page_aiimagepro' != $hook && 'aiimagepro' != $hook ) {
            return;
        }

        $version = aiimagepro_get_plugin_version();
        if ($version === false) {
            $version = rand( 1, 10000000 );
        }

        wp_enqueue_script( 'fabric', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/js/fabric.js', array(), $version );
        wp_enqueue_script( 'aiimagepro-editor', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/js/editor.js', array('jquery', 'fabric', 'the-cropper'), $version );
        wp_enqueue_script( 'bootstrap', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/js/bootstrap.bundle.min.js', array(), $version );
        wp_enqueue_script( 'the-cropper', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/js/cropper.min.js', array(), $version );

        wp_enqueue_style( 'aiimagepro-editor', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/css/editor.css', array(), $version );
        wp_enqueue_style( 'bootstrap', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/css/bootstrap.min.css', array(), $version );
        wp_enqueue_style( 'bootstrap-icons', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/css/bootstrap-icons.css', array(), $version );
        wp_enqueue_style( 'the-cropper', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/css/cropper.min.css', array(), $version );
        wp_enqueue_style( 'google-font', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/css/fonts.css', array(), $version );

        // if the page has parameter embedded=true, then add the embedded css file
        if (isset($_GET['embedded']) && $_GET['embedded'] == 'true') {
            wp_enqueue_style( 'aiimagepro-embedded', rtrim(plugin_dir_url( __FILE__ ), '/') . '/../../assets/css/embedded.css', array(), $version );
        }

        wp_enqueue_media();  // for media library
    }

}
